﻿using Infragistics.Documents.RichText;
using Infragistics.Themes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamRichTextEditorExtraSpaceCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ThemeManager.ApplicationTheme = new IgTheme();

            string error = null;
            TableNode tn = this.richTextEditor1.Document.InsertTable(0, 5, 100, out error);

            CharacterSettings charSettings = new CharacterSettings()
            {
                Color = new ColorInfo(Color.FromArgb(255, 85, 85, 85))
            };

            // setting for headers
            TableCellSettings headerSettings = new TableCellSettings();
            headerSettings.Shading = new Shading(new ColorInfo(Colors.AliceBlue));

            // settings for non-highlighted rows
            TableCellSettings rowSettings = new TableCellSettings();
            rowSettings.Shading = new Shading(new ColorInfo(Colors.LightGray));

            // settings for highlighted rows
            TableCellSettings rowAlternatingSettings = new TableCellSettings();
            rowAlternatingSettings.Shading = new Shading(new ColorInfo(Colors.LightGray));

            // create table settings
            RichTextBorder tableBorder = new RichTextBorder()
            {
                Color = Color.FromArgb(255, 224, 224, 224),
                BorderType = RichTextBorderType.Single,
                Size = new Extent(1, ExtentUnitType.LogicalPixels),
            };
            TableSettings tableSettings = new TableSettings();
            tableSettings.Borders = new TableBorderSettings();
            tableSettings.Borders.Top = tableBorder;
            tableSettings.Borders.Bottom = tableBorder;
            tableSettings.Borders.Start = tableBorder;
            tableSettings.Borders.End = tableBorder;

            tn.Settings = tableSettings;

            if (error == null)
            {
                int cRow = 1;
                foreach (TableRowNode trn in tn.ChildNodes)
                {
                    int cCell = 1;
                    foreach (TableCellNode tcn in trn.ChildNodes)
                    {
                        tcn.Settings = rowSettings;
                        ParagraphNode pn = tcn.ChildNodes[0] as ParagraphNode;
                        pn.SetText(string.Format("Row {0}, Cell {1}", cRow, cCell));
                        cCell++;
                    }
                    cRow++;
                }
            }
        }
    }
}
